/*****************************************************************************/
/* CHECKSCR.C  check current screen mode EGA/VGA ,Herc or CHINESE (CSI) mode */
/*****************************************************************************/
#pragma inline

#include<dos.h>
#include<conio.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<process.h>
#include<string.h>

void ChineseInt10(char ch)
{
   short aa=ch;
   asm   mov   ah,80h
   asm   mov   al,aa
   asm   int   10h
}
/* Frame : draw frame (english four modes ) */
void Frame(char left,char top,char right,char bottom)
{
   char  i;
   char  topleft,topright,bottomleft,bottomright,v,h;
   char  x=wherex(),y=wherey();

   gotoxy(left,top);
               topleft     = '';
               topright    = '';
               bottomleft  = '';
               bottomright = '';
               v           = '';
               h           = '';
   putch(topleft);
   for(i=left+1;i<right;i++)
      gotoxy(i,top),putch(h),gotoxy(i,bottom),putch(h);
   for(i=top+1;i<bottom;i++)
      gotoxy(left,i),putch(v),gotoxy(right,i),putch(v);
   gotoxy(right,bottom),putch(bottomright);
   gotoxy(right,top),putch(topright);
   gotoxy(left,bottom),putch(bottomleft);
   gotoxy(x,y);
}

/* CFrame : draw frame (chinese seven modes ) */
void CFrame(char left,char top,char right,char bottom)
{
   char  i;
   char  topleft[2],topright[2],bottomleft[2],bottomright[2],v[2],h[2];
   char  x=wherex(),y=wherey();
               topleft[0]     = '';  topleft[1]     = '';    /*    */
               topright[0]    = '';  topright[1]    = '';    /*    */
               bottomleft[0]  = '';  bottomleft[1]  = '';    /*    */
               bottomright[0] = '';  bottomright[1] = '';    /*    */
               v[0]           = '';  v[1]           = '';    /*    */
               h[0]           = '';  h[1]           = '';    /*    */
   gotoxy(left,top),putch(topleft[0]),putch(topleft[1]);
   for(i=left+2;i<right;i=i+2)
      gotoxy(i,top),putch(h[0]),putch(h[1]),gotoxy(i,bottom),putch(h[0]),putch(h[1]);
   for(i=top+1;i<bottom;i++)
      gotoxy(left,i),putch(v[0]),putch(v[1]),gotoxy(right,i),putch(v[0]),putch(v[1]);
   gotoxy(right,bottom),putch(bottomright[0]),putch(bottomright[1]);
   gotoxy(right,top),putch(topright[0]),putch(topright[1]);
   gotoxy(left,bottom),putch(bottomleft[0]),putch(bottomleft[1]);
   gotoxy(x,y);
}
unsigned char far *Pvideo=(char far *)0xC0000000;
unsigned char *ID4000="\x55\xAA\x40";
unsigned char *ID3000="\x55\xAA\x30";
unsigned char *Tseng="Tseng Lab";
unsigned char *S3   =" S3 86C8";
unsigned char id[20];
char IsET4000(void)
{
   int i,j;
   j=strlen(Tseng);
   for(i=0;i<j;i++) id[i]=*(Pvideo+0x76+i); id[i]='\0';
   if(strncmp(id,Tseng,j)!=0)return 0;

   for(i=0;i<3;i++) id[i]=*(Pvideo+i); id[i]='\0';
   if(strncmp(id,ID4000,i)!=0)return 0;

   return 1;
}
char IsET3000(void)
{
   int i,j;
   j=strlen(Tseng);
   for(i=0;i<j;i++) id[i]=*(Pvideo+0x76+i); id[i]='\0';
   if(strncmp(id,Tseng,j)!=0)return 0;

   for(i=0;i<3;i++) id[i]=*(Pvideo+i); id[i]='\0';
   if(strncmp(id,ID3000,i)!=0)return 0;

   return 1;
}
char IsS3(void)
{
   int i,j;
   j=strlen(S3);
   for(i=0;i<j;i++) id[i]=*(Pvideo+0x4B+i); id[i]='\0';
   if(strncmp(id,S3,j)!=0)return 0;

   for(i=0;i<3;i++) id[i]=*(Pvideo+i); id[i]='\0';
   if(strncmp(id,ID4000,i)!=0)return 0;

   return 1;
}
char *Decode1(char *t)
{
   unsigned int slen=(t[0]&0x00FF)|(t[1]&0xFF00);
   unsigned char sseed=t[0];
   unsigned int i;
   for(i=slen+1;i>2;i--)
      t[i]-=t[i-1];
      t[i]-=sseed;
   return t+2;     /* Offset 2 */
}
char *Encode1(char *t)
{
   unsigned int slen=(*(t-2)&0x00FF)|(*(t-1)&0xFF00);
   unsigned char sseed=*(t-2);
   unsigned int i;
   t[0]+=sseed;
   for(i=1;i<slen;i++)
      t[i]+=t[i-1];
   return t-2;     /* Offset 2 */
}
char ChineseSystem(void)
{
   asm   mov   ax,09100h
   asm   mov   bx,0
   asm   mov   cx,0
   asm   mov   dx,0
   asm   int   10h
   asm   cmp   bx,0
   asm   je    NotInET
   return 1;
NotInET:
   return 0;
}
void main(int argc,char *argv[])
{
   double Ver=1.21;
   char *aword1=   /*Check Screen Mode   version %4.2f   Free Registered     by  Lee Dong-Liang*/
      "\x4A\x00"
      "\x8D\xF5\x5A\xBD\x28\x48\x9B\xFE\x70\xD5\x3A\xA8\xC8\x15\x84\xE8"
      "\x4D\x6D\x8D\xAD\x23\x88\xFA\x6D\xD6\x45\xB3\xD3\xF8\x2C\x5A\x8C"
      "\xF2\x12\x32\x52\x98\x0A\x6F\xD4\xF4\x46\xAB\x12\x7B\xEE\x62\xC7"
      "\x39\x9E\x02\x22\x42\x62\x82\xA2\x04\x7D\x9D\xBD\x09\x6E\xD3\xF3"
      "\x37\xA6\x14\x7B\xA8\xF4\x5D\xBE\x2C\x93";
   char *aword2="Jan,1994    Using   CHECKSCR /?  or  CHECKSCR ?   to see more information";
   char *Help=
  "\n   CHECKSCR  will detect current screen mode and return an ERROR CODE to DOS"
"\n\n   CODE ==  1  -- EGA            CODE ==  11  -- EGA & CMEX Chinese System"
  "\n   CODE ==  2  -- VGA (Other)    CODE ==  12  -- VGA & CMEX Chinese System"
  "\n   CODE ==  3  -- MGA            CODE ==  13  -- MGA & CMEX Chinese System"
  "\n   CODE ==  4  -- VGA ET4000     CODE ==  14  -- VGA & CMEX Chinese System"
  "\n   CODE ==  5  -- VGA ET3000     CODE ==  15  -- VGA & CMEX Chinese System"
  "\n   CODE ==  6  -- VGA S3         CODE ==  16  -- VGA & CMEX Chinese System"
"\n\n   Usage :"
"\n\n   CHECKSCR [NOMSG]     using option NOMSG , the title message will not show\n";
   char *emptylines="\n\n\n\n\n";
   char *msg1="\t%s detected.";
   char *msg2="\t%s & CMEX Chinese System detected.";

   int chinese,graphmode,value=0,Msgflag=1;
   char scry;

   scry=wherey();
   scry=(scry>20)?20:scry;
   if(stricmp(argv[1],"nomsg")==0)Msgflag=0;

   chinese=ChineseSystem();
   aword1=Decode1(aword1);
   if(chinese==1)                   /* CMEX Chinese System */
   {
      ChineseInt10('N');
      if(Msgflag!=0)
      {
         printf(emptylines);
         CFrame(1,scry,79,scry+3);
         gotoxy(4,scry+1);printf(aword1,Ver);
         gotoxy(4,scry+2);printf(aword2);
         gotoxy(1,scry+4);
      }
      value+=10;
   }
   else  if(Msgflag!=0)
         {
            printf(emptylines);
            Frame(1,scry,79,scry+3);
            gotoxy(4,scry+1);printf(aword1,Ver);
            gotoxy(4,scry+2);printf(aword2);
            gotoxy(1,scry+4);
         }
   aword1=Encode1(aword1);

   if(argc>=2 && Msgflag!=0)puts(Help);

   graphmode=ScrChk();
   if(graphmode==0)                  /* EGA */
      value+=1;
   else  if(graphmode==2)            /* VGA */
         {
            if(IsET4000()==1) value+=4;         /* ET4000 */
            else  if(IsET3000()==1) value+=5;   /* ET3000 */
                  else  if(IsS3()==1) value+=6; /* S3     */
                        else value+=2;          /* Other  */
         }
         else  if(graphmode==3)      /* MGA */
                  value+=3;

   if(Msgflag!=0)
      switch(value)
      {
         case  1: printf(msg1,"EGA");break;
         case  2: printf(msg1,"VGA (unknown)");break;
         case  3: printf(msg1,"MGA");break;
         case  4: printf(msg1,"VGA (ET4000)");break;
         case  5: printf(msg1,"VGA (ET3000)");break;
         case  6: printf(msg1,"VGA (S3)");break;

         case 11: printf(msg2,"EGA");break;
         case 12: printf(msg2,"VGA (unknown)");break;
         case 13: printf(msg2,"MGA");break;
         case 14: printf(msg2,"VGA (ET4000)");break;
         case 15: printf(msg2,"VGA (ET3000)");break;
         case 16: printf(msg2,"VGA (S3)");break;
         default: printf(msg1,"(unknown)");break;
      }

   exit(value);
}
/******************************************************************************
Version 1.21
   1. Add detect  Quadtel S3 86C801/805
   2. Bugfix about detect ET4000

Version 1.2
   1. Change the Chinese System to
      INT 10h   using function  91h  (ax=09100h).
      This can check the ETen and HAN Chinese System.

Version 1.1
   1. Adding test of ET4000 & ET3000.
   2. If Chinese mode , program will set it to "english-maths" input mode.
      This will let the ETen Chinese Message Line appear.
   3. Author's String Encode.

Version 1.0
   1. Test Screen Mode EGA,VGA,MGA or with CMEX Chinese mode.
******************************************************************************/
