/**************************************************************************/
/* LINES.C    save video, draw lines, and then put saved text back        */
/**************************************************************************/
#include<alloc.h>
#include<graphics.h>
#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#define LEFT 0
#define TOP  0

char *ETitle=
"   Ŀ\n"
"     Screen Saver (English/Chinese Mode)                Copyright (C)  \n"
"     Version 1.2    Free Registered    1990-93     by  Lee Dong-Liang  \n"
"   ;";
char *EHelp=
"\n\n     Usage :\n"
"        LINES [options]\n"
"     Options :\n"
"        /C:nnn   lines to change color          default=Random(1-128)\n"
"        /D:nnn   time Delay in milli-second     default=50\n"
"        /L:nnn   lines to keep in screen        default=Random(1-64)\n"
"        /M:E [C] Sreen Mode in English/Chinese  default=AutoDetect\n"
"        /P:x,y   Start position                 default=Random\n"
"        /S:X,Y   Sreen Size                     default=AutoDetect\n"
"        /?       This Help";
char *CTitle=
"   zwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww{\n"
"   x ùO@{ (B^Ҧ)                        Copyright (C) x\n"
"   x Version 1.2      Free Registered      1990-93      by      x\n"
"   ";
char *CHelp=
"\n\n      k :\n"
"        LINES [\\]\n"
"     Options :\n"
"        /C:nnn     ۨCC⪺u A    w]=ü (1-128)\n"
"        /D:nnn     ɶ (쬰@)    w]=50\n"
"        /L:nnn     Oduƥ A        w]=ü (1-64)\n"
"        /M:E [C]   ]wB^Ҧ         w]=۰ʰ\n"
"        /P:x,y     u}lm             w]=ü\n"
"        /S:X,Y     ùjp                 w]=۰ʰ\n"
"        /?         ";

void INT_10(char ch)
{
   short aa=ch;
   asm   mov   ah,80h
   asm   mov   al,aa
   asm   int   10h
}

int ErrorCode=0;
int GraphDriver;
int GraphMode;
int MaxColors;
int MaxX,MaxY;

void RegisterDrivers()
{
   if(registerbgidriver(EGAVGA_driver )<0) exit(1);
   if(registerbgidriver(Herc_driver   )<0) exit(1);
}

void Initialize()
{
   GraphDriver=DETECT;
   initgraph(&GraphDriver,&GraphMode,"");
   ErrorCode=graphresult();
   if(ErrorCode != grOk)
   {
      printf("\nGraphics System Error : %s\n",grapherrormsg(ErrorCode));
                delay(10);
      exit(1);
   }
   MaxColors=getmaxcolor()+1;
   MaxX=getmaxx();
   MaxY=getmaxy();
}
void eline(int x1,int y1,int x2,int y2,int colors)
{
   setcolor(colors);
   line(x1,y1,x2,y2);
}
void cline(int x1,int y1,int x2,int y2,int colors)
{
   gotoxy(1,1);                              /* Ver 1.2  for  v.s. PcCline */
   printf("L%d,%d,%d,%d,%d;",x1,y1,x2,y2,colors);
}
main(int argc,char *argv[])
{
   unsigned int  count=0;
   int  t=0;    /* line number */
   char  flag=0,first=1;
   int  colors=1;
   int  DTime=50;
   int  CLINES;
   int  LINES;
   void (*ecline)();
   char CHINESE;
   int  i,j;
   int  x0,y0,x1,y1,x2,y2,dx1,dy1,dx2,dy2;
   char X2[5];
   char *buf;            /*[80*25*2];*/
   int  *p1[2],*p2[2];   /*[LINES]*/

   randomize();

   CLINES=random(128)+1;
   LINES =random(64)+1;
   if(SysCheck()) CHINESE=1;
   else           CHINESE=0;
   if(CHINESE==1)
   {
      INT_10('C');                           /* "\x1BIC;" set CHINESE input */
      INT_10('c');                           /* "\x1BIc;" set ENGLISH input */
      MaxX=639;
      if((x2=ScrChk())==0) MaxY=374,MaxColors=16;  /* EGA  ver 1.1 */
      else  if(x2==2)      MaxY=449,MaxColors=16;  /* VGA */
            else           MaxY=374,MaxColors=2;   /* MGA */
   }
   x2=y2=0;
   if(argc>=2)
   {
      for(i=1;i<argc;i++)
      {
         if(strnicmp(argv[i],"/P:",3)==0)
         {
            flag=1;
            for(j=0;j<5;j++)
               if(argv[i][j+3]==',')
               {
                  X2[j]='\0';
                  j++;
                  break;
               }
               else
                  X2[j]=argv[i][j+3];
            X2[4]='\0';
            y2=(atoi(argv[i]+j+3)<0)?0:atoi(argv[i]+j+3);
            x2=(atoi(X2)<0)?0:atoi(X2);
            continue;
         }
         if(strnicmp(argv[i],"/S:",3)==0)
         {
            flag=1;
            for(j=0;j<5;j++)
               if(argv[i][j+3]==',')
               {
                  X2[j]='\0';
                  j++;
                  break;
               }
               else
                  X2[j]=argv[i][j+3];
            X2[4]='\0';
            MaxY=(atoi(argv[i]+j+3)<0)?0:atoi(argv[i]+j+3);
            MaxX=(atoi(X2)<0)?0:atoi(X2);
            continue;
         }
         if(strnicmp(argv[i],"/D:",3)==0)
         {
            flag=1;
            DTime=(atoi(argv[i]+3)<0)?DTime:atoi(argv[i]+3);
            continue;
         }
         if(strnicmp(argv[i],"/L:",3)==0)
         {
            flag=1;
            LINES=(atoi(argv[i]+3)<0)?LINES:atoi(argv[i]+3);
            continue;
         }
         if(strnicmp(argv[i],"/C:",3)==0)
         {
            flag=1;
            CLINES=(atoi(argv[i]+3)<0)?LINES:atoi(argv[i]+3);
            continue;
         }
         if(strnicmp(argv[i],"/M:E",4)==0)
         {
            flag=1;
            CHINESE=0;
            continue;
         }
         if(strnicmp(argv[i],"/M:C",4)==0)
         {
            flag=1;
            CHINESE=1;
            continue;
         }
         if(strnicmp(argv[i],"/?",2)==0)
         {
            flag=0;
            break;
         }
      }
      if(flag==0)
      {
         if(CHINESE==1)printf(CTitle), printf(CHelp);
         else          printf(ETitle), printf(EHelp);
         exit(0);
      }
      flag=0;
   }
   if(CHINESE==1) printf(CTitle);
   else           printf(ETitle);

   buf=(char *)calloc(80*25*2,sizeof(char));
   for(i=0;i<2;i++)p1[i]=(int *)calloc(LINES,sizeof(int));
   for(i=0;i<2;i++)p2[i]=(int *)calloc(LINES,sizeof(int));

   x0=wherex();y0=wherey();
   gettext(1,1,80,25,buf);
   clrscr();
   if(CHINESE==1)
   {
      INT_10('M');                           /* "\x1BIM;" Off Message Line */
      Cursor(0);                             /* Off Cursor  ver 1.1 */
      ecline=cline;
   }
   else
   {
      RegisterDrivers();
      Initialize();
      ecline=eline;
   }
   x1=y1=0;                            /* First point in 0,0 */
   x2=(x2==0)?random(MaxX)+1:x2;       /* Second point use usersetup */
   y2=(y2==0)?random(MaxY)+1:y2;       /* position or random position */
   dx1=dy1=5;                          /* position change in first point */
   dx2=dy2=7;                          /* position change in second point */
   while(flag==0)
   {
      count++;
      if(kbhit()){getch();flag=1;}
      ecline(x1,y1,x2,y2,colors);
      ecline(x1,MaxY-y1,x2,MaxY-y2,colors);
      ecline(MaxX-x1,MaxY-y1,MaxX-x2,MaxY-y2,colors);
      ecline(MaxX-x1,y1,MaxX-x2,y2,colors);
      delay(DTime);
      if(count>=LINES || first==0)
      {
         first=0;
         /*t=(count-LINES) % LINES;*/
         t=count % LINES;
         ecline(p1[0][t],p1[1][t],p2[0][t],p2[1][t],0);
         ecline(p1[0][t],MaxY-p1[1][t],p2[0][t],MaxY-p2[1][t],0);
         ecline(MaxX-p1[0][t],MaxY-p1[1][t],MaxX-p2[0][t],MaxY-p2[1][t],0);
         ecline(MaxX-p1[0][t],p1[1][t],MaxX-p2[0][t],p2[1][t],0);
      }
      t=count % LINES;
      if(count%CLINES == 0)
      {
         colors+=1;
         colors%=MaxColors;
         if(colors==0)colors+=1;
      }
      p1[0][t]=x1;p1[1][t]=y1;
      p2[0][t]=x2;p2[1][t]=y2;
      x1+=dx1;y1+=dy1;
      x2+=dx2;y2+=dy2;
      if(x1<=LEFT || x1>=MaxX)dx1=-dx1;
      if(y1<=TOP || y1>=MaxY)dy1=-dy1;
      if(x2<=LEFT || x2>=MaxX)dx2=-dx2;
      if(y2<=TOP || y2>=MaxY)dy2=-dy2;
      if(count % (CLINES*LINES)==0)count=0;
   }
   if(CHINESE==1) INT_10('m');          /* On ETen Message Line */
   else           closegraph();         /* Close Graphics (English Mode) */
   if(CHINESE==1) clrscr(),Cursor(1);   /* Cursor(1) -- ver 1.1 */
   puttext(1,1,80,25,buf);
   gotoxy(x0,y0);
}
